package eserciziArray.esercizio09;
import java.util.Arrays;



/* Testo esercizio:
 * ----------------
 * 
 * Costruiamo un calendario del 2024.
 * Partendo da questi dati:
 * final int NUMERO_MESI = 12;
 * int [] numeroGiorniPerMese = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
 * String [] giorno = {"Lunedi", "Martedi", "Mercoledi", "Giovedi", "Venerdi", "Sabato", "Domenica"};
 * Sviluppare due iterazioni che riempiano una struttura array Calendario
 * String [][] calendario = new String [12][31];
 * Ricordatevi di partire dal lunedì (1 Gennaio 2024)!
 * Il programma dovrà restituire il giorno di oggi:
 * 
 *  Oggi è Giovedi
 *  
 *  Note:
 *  01/01/2024 lunedì
 *  31/01/2024 mercoledì
 *  01/12/2024 domenica
 *  31/12/2024 martedì
 */ 
public class Esercizio09 {

	private final int 	NUMERO_MESI = 12;
	private int[] 		numeroGiorniPerMese = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	private String[] 	giorno = {"Lunedi", "Martedi", "Mercoledi", "Giovedi", "Venerdi", "Sabato", "Domenica"};
    
	private static final int  OFFSET_YEARDAY_2024 = 0;
	
	private String [][] calendario = new String [12][31];
	
	
	public Esercizio09() {
		initCalendar2024();
	}
	
	
	private void initCalendar2024() {
		calendario = new String [12][31];
		
		//indici per "numeroGiorniPerMese"
		int jBegin			= 0;
		int jLength 		= 0;
		
		//indici per "giorno"
		int kBegin			= 0;
		int kBeginJanuary   = 0;
		int kLength			= 0;
		
		//indice del giorno dell'anno
		int indexYearDay	= 0;
		int indexWeekDay	= 0;
		
		
		int monthIndex		= 0;
		int dayIndex		= 0;
		
		
		//"kBeginJanuary" anno 2021
		kBeginJanuary   = 4;
		
		
		//Loop per i mesi dell'anno
		indexYearDay	= -1;
		
		indexYearDay	+= OFFSET_YEARDAY_2024;
		
		for (int i=0; i<NUMERO_MESI;  i++) {
			
			jBegin			= 0;
			jLength 		= numeroGiorniPerMese[i];
			//Loop per i giorni di un mese
			for (int j=jBegin; j<jLength; j++) {
				indexYearDay++;
				
				
				
				indexWeekDay = indexYearDay%giorno.length;
				
				//System.out.println("indice mese = " + i + "  indice giorno = " +  j + "  indice giorno settimana = " + indexWeekDay + " giorno settimana = " + giorno[indexWeekDay]); 
				
				calendario[i][j] = giorno[indexWeekDay];
				
				
				
			}

		}
		
	}
	
	
	public String getWeekDay2024(int month, int day) {
		String result = "";
		
		result =  calendario[month-1][day-1];
		
		return result;
	}
	
	
}
